import type { Database as SqLiteConnection } from "better-sqlite3";
import { LuciaAdapter } from "./abstract.js";
import type { IdTokenClaims, TokenSet, UserinfoResponse } from "openid-client";
import type { UserId, Session } from "lucia";
import type { MaybePromise } from "@sveltejs/kit";
declare class SqliteMemoryLuciaAdapter extends LuciaAdapter<Record<never, never>, User> {
    db: SqLiteConnection;
    constructor();
    initDatabase(): void;
    getUserId(subject: string): string | undefined;
    newUser(subject: string, userId: string, claims: IdTokenClaims): string;
    newSession(userId: UserId, tokenSet: TokenSet & {
        id_token: string;
    }): Promise<Session>;
    getIdToken(session: Session): MaybePromise<string | undefined>;
}
export declare const adapter: SqliteMemoryLuciaAdapter;
interface DatabaseUser {
    id: string;
    subject: string;
    claims: string;
}
interface User {
    subject: string;
    claims: UserinfoResponse;
}
interface DatabaseSession {
    idToken: string;
}
declare module "@arise/aidc-sveltekit" {
    interface Types {
        Session: DatabaseSession;
        User: User;
        DatabaseSessionAttributes: DatabaseSession;
        DatabaseUserAttributes: DatabaseUser;
    }
}
export {};
